SystemOrganization addCategory: #'CodeMine-Grammar'!
SystemOrganization addCategory: #'CodeMine-Text'!
SystemOrganization addCategory: #'CodeMine-LanguageModel'!
SystemOrganization addCategory: #'CodeMine-Test-Mocks'!
SystemOrganization addCategory: #'CodeMine-CallGraph'!
SystemOrganization addCategory: #'CodeMine-Tracing'!
SystemOrganization addCategory: #'CodeMine-UI'!
SystemOrganization addCategory: #CodeMine!

CircleMorph subclass: #CUIProjectedItem
	instanceVariableNames: 'projection components item label'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeMine-UI'!

!CUIProjectedItem methodsFor: 'as yet unclassified' stamp: 'toma 2/17/2017 17:13'!
addLabel: aString
	| label |
	label := (CUIProjectedItemLabel new)
		left: (self right + 10);
		top: (self top - 10);
		contents: aString;
		show;
		yourself.
	self label: label.
	^label! !

!CUIProjectedItem methodsFor: 'accessing' stamp: 'toma 2/14/2017 14:04'!
components

	^ components! !

!CUIProjectedItem methodsFor: 'accessing' stamp: 'toma 2/14/2017 14:04'!
components: anObject

	components := anObject! !

!CUIProjectedItem methodsFor: 'as yet unclassified' stamp: 'toma 2/14/2017 18:42'!
initialize
	super initialize.
	self extent: 10@10;
		color: Color transparent;
		borderColor: Color blue.
	! !

!CUIProjectedItem methodsFor: 'accessing' stamp: 'toma 2/14/2017 14:07'!
item

	^ item! !

!CUIProjectedItem methodsFor: 'accessing' stamp: 'toma 2/14/2017 14:07'!
item: anObject

	item := anObject! !

!CUIProjectedItem methodsFor: 'accessing' stamp: 'toma 2/14/2017 18:48'!
label

	^ label! !

!CUIProjectedItem methodsFor: 'accessing' stamp: 'toma 2/17/2017 17:14'!
label: anObject

	label ifNotNilDo: [ :theLabel | self removeMorph: theLabel ].
	label := anObject.
	self addMorph: label.
	! !

!CUIProjectedItem methodsFor: 'accessing' stamp: 'toma 2/14/2017 14:04'!
projection

	^ projection! !

!CUIProjectedItem methodsFor: 'accessing' stamp: 'toma 2/14/2017 14:04'!
projection: anObject

	projection := anObject! !

PolygonMorph subclass: #TopicProjection
	instanceVariableNames: 'items'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeMine-UI'!

!TopicProjection methodsFor: 'as yet unclassified' stamp: 'toma 2/14/2017 14:00'!
addVertices: count scale: scale x: x y: y
	| vertices |
	vertices := OrderedCollection new.
	(0 to: count - 1) do: [:i | | angle |
		angle := (2 * Float pi) * i / count.
		 vertices add: (angle sin * scale + x) @ (angle cos negated * scale + y)].
	self vertices: vertices color: Color white borderWidth: 2 borderColor: Color black muchDarker.
	
	
	! !

!TopicProjection methodsFor: 'as yet unclassified' stamp: 'toma 2/17/2017 17:02'!
initialize
	super initialize.
	self items: OrderedCollection new.
	self addVertices: 5 scale: 300 x: 0 y: 0.! !

!TopicProjection methodsFor: 'accessing' stamp: 'toma 2/17/2017 16:45'!
items

	^ items! !

!TopicProjection methodsFor: 'accessing' stamp: 'toma 2/17/2017 16:45'!
items: anObject

	items := anObject! !

!TopicProjection methodsFor: 'as yet unclassified' stamp: 'toma 2/14/2017 18:36'!
mapProjection: vector
	| x y total |
	total := vector sum.
	self assert: total > 0.
	x := 0.
	y := 0.
	self vertices withIndexDo: [ :vertex :index | | part |
		part := (vector at: index) / total.
		x := x + (part * vertex x).
		y := y + (part * vertex y)].
	^ x @ y! !

!TopicProjection methodsFor: 'as yet unclassified' stamp: 'toma 2/17/2017 16:44'!
project: item atCoordinates: vector
	| projectedItem |
	projectedItem := (CUIProjectedItem new)
		item: item;
		center: (self mapProjection: vector);
		show;
		yourself.
	self items add: projectedItem.
	self addMorph: projectedItem.
	^projectedItem! !

RBProgramNodeVisitor subclass: #CMCallGraphBuilder
	instanceVariableNames: 'currentMethod callGraph currentVariable definitions currentSelf controlFlow currentStatement'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeMine'!

!CMCallGraphBuilder class methodsFor: 'as yet unclassified' stamp: 'toma 8/12/2015 18:02'!
forGraph: aCallGraph
	
	^(CMCallGraphBuilder new)
		callGraph: aCallGraph;
		yourself.
		! !

!CMCallGraphBuilder methodsFor: 'as yet unclassified' stamp: 'toma 8/17/2015 15:20'!
acceptMessageNode: aMessageNode
	| selector |


	selector := self callGraph selectorFor: aMessageNode selector.
	self currentStatement: (self currentMethod newCallTo: selector).
	super acceptMessageNode: aMessageNode.

	! !

!CMCallGraphBuilder methodsFor: 'as yet unclassified' stamp: 'toma 8/17/2015 15:50'!
acceptMethodNode: aMethodNode
	
	| selector |
	selector := self callGraph selectorFor: (
		aMethodNode selector asSymbol).
	self currentMethod: (selector newImplementor: aMethodNode).
	self definitions: Dictionary new.
	self definitions at: 'self' put: (self currentSelf).
.
	aMethodNode argumentNames do: [ :arg |
		self definitions at: arg put: (CMArgumentDependency named: arg)].

	self callGraph methods add: (self currentMethod).
	super acceptMethodNode: aMethodNode.! !

!CMCallGraphBuilder methodsFor: 'as yet unclassified' stamp: 'toma 1/29/2016 14:50'!
acceptVariableNode: aVariableNode
	self currentMethod vocabulary add: (aVariableNode name).
	super acceptVariableNode: aVariableNode.! !

!CMCallGraphBuilder methodsFor: 'accessing' stamp: 'toma 8/12/2015 18:02'!
callGraph
	^ callGraph! !

!CMCallGraphBuilder methodsFor: 'accessing' stamp: 'toma 8/12/2015 18:02'!
callGraph: anObject
	callGraph := anObject! !

!CMCallGraphBuilder methodsFor: 'accessing' stamp: 'toma 8/17/2015 15:02'!
controlFlow
	^ controlFlow! !

!CMCallGraphBuilder methodsFor: 'accessing' stamp: 'toma 8/17/2015 15:02'!
controlFlow: anObject
	controlFlow := anObject! !

!CMCallGraphBuilder methodsFor: 'accessing' stamp: 'toma 8/12/2015 18:02'!
currentMethod
	^ currentMethod! !

!CMCallGraphBuilder methodsFor: 'accessing' stamp: 'toma 8/12/2015 18:02'!
currentMethod: anObject
	currentMethod := anObject! !

!CMCallGraphBuilder methodsFor: 'accessing' stamp: 'toma 8/17/2015 15:28'!
currentSelf
	^ currentSelf! !

!CMCallGraphBuilder methodsFor: 'accessing' stamp: 'toma 8/17/2015 15:28'!
currentSelf: anObject
	currentSelf := anObject! !

!CMCallGraphBuilder methodsFor: 'accessing' stamp: 'toma 8/17/2015 15:18'!
currentStatement
	^ currentStatement! !

!CMCallGraphBuilder methodsFor: 'accessing' stamp: 'toma 8/17/2015 15:18'!
currentStatement: anObject
	currentStatement := anObject! !

!CMCallGraphBuilder methodsFor: 'accessing' stamp: 'toma 8/17/2015 15:02'!
definitions
	^ definitions! !

!CMCallGraphBuilder methodsFor: 'accessing' stamp: 'toma 8/17/2015 15:02'!
definitions: anObject
	definitions := anObject! !

!CMCallGraphBuilder methodsFor: 'as yet unclassified' stamp: 'toma 8/17/2015 15:02'!
initialize 

	super initialize.
	definitions := Dictionary new.! !

!CMCallGraphBuilder methodsFor: 'as yet unclassified' stamp: 'toma 8/14/2015 11:57'!
scanCategoryPrefix: aString

	^self scanCategoryPrefix: aString excluding: [ :class | false ]
! !

!CMCallGraphBuilder methodsFor: 'as yet unclassified' stamp: 'toma 8/13/2015 15:33'!
scanCategoryPrefix: aString excluding: aBlock

	((Object allSubclasses
		select: [ :class |
			class category ifNil: [false] ifNotNilDo: [:cat | cat beginsWith: aString]])
		select: [ :class |
			(aBlock value: class) not]) 
		do: [: class |
			self scanClass: class].
! !

!CMCallGraphBuilder methodsFor: 'as yet unclassified' stamp: 'toma 8/17/2015 15:37'!
scanClass: aClass

	self currentSelf: (CMSelfDependency newForClass: aClass).

	aClass methodDict valuesDo: [ :method | 	| node |
		node := RBParser parseMethod: (method getSource asString).
		self visitNode: node.
	]
! !

RBProgramNodeVisitor subclass: #CMCondenser
	instanceVariableNames: 'stream tagStack translation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeMine'!

!CMCondenser class methodsFor: 'as yet unclassified' stamp: 'toma 2/8/2016 11:46'!
on: aStream

	^(CMTreeExporter new)
		stream: aStream; 
		yourself! !

!CMCondenser methodsFor: 'as yet unclassified' stamp: 'toma 2/8/2016 11:46'!
acceptArrayNode: anArrayNode
	self inside: 'array' do: [
		super acceptArrayNode: anArrayNode]! !

!CMCondenser methodsFor: 'as yet unclassified' stamp: 'toma 2/8/2016 11:46'!
acceptAssignmentNode: aNode
	self inside: 'assignment' do: [
			self inside: 'to' do: [self visitNode:  aNode variable].
			self inside: 'value' do: [self visitNode: aNode value]]
			! !

!CMCondenser methodsFor: 'as yet unclassified' stamp: 'toma 2/8/2016 11:46'!
acceptBlockNode: aNode
	self inside: 'block' do: [
		aNode arguments ifNotEmpty: [
		self inside: 'args' do: [
			self visitArguments: aNode arguments]].
		self inside: 'body' do: [
			self visitNode: aNode body.]]! !

!CMCondenser methodsFor: 'as yet unclassified' stamp: 'toma 2/8/2016 11:46'!
acceptCascadeNode: aNode
	self inside: 'cascade' do: [
		super acceptCascadeNode: aNode]! !

!CMCondenser methodsFor: 'as yet unclassified' stamp: 'toma 2/8/2016 11:46'!
acceptLiteralArrayNode: aNode
	self inside: 'literals' do: [
		super acceptLiteralArrayNode: aNode.]	! !

!CMCondenser methodsFor: 'as yet unclassified' stamp: 'toma 2/8/2016 11:46'!
acceptLiteralNode: aNode
		self text: (aNode value asString) tagged: 'literal'! !

!CMCondenser methodsFor: 'as yet unclassified' stamp: 'toma 2/8/2016 11:46'!
acceptMessageNode: aNode
	self inside: 'message' 
	with: {'selector' -> aNode selector asString}
	do: [	
			(aNode isCascaded not or: [aNode isFirstCascaded]) 
				ifTrue: [
					self inside: 'receiver' do:  [
						self visitNode: aNode receiver]].
			aNode arguments ifNotEmpty: [
				self inside: 'args' do: [
					aNode arguments do: [
						:each | self visitNode: each]]]].! !

!CMCondenser methodsFor: 'as yet unclassified' stamp: 'toma 2/8/2016 11:46'!
acceptMethodNode: aNode
	self inside: 'method' 
	with: {'selector' -> aNode selector asString}
	do: [
		aNode arguments ifNotEmpty: [
			self inside: 'args' do: [
				self visitArguments: aNode arguments]].
		aNode pragmas ifNotEmpty: [
			self inside: 'pragmas' do: [
				aNode pragmas	do: [ :each | self visitNode: each ]]].
		self inside: 'body' do: [
			self visitNode: aNode body]].! !

!CMCondenser methodsFor: 'as yet unclassified' stamp: 'toma 2/8/2016 11:46'!
acceptPatternBlockNode: aNode
	self fail: 'Not Implemented'! !

!CMCondenser methodsFor: 'as yet unclassified' stamp: 'toma 2/8/2016 11:46'!
acceptPatternWrapperBlockNode: aNode
	self fail: 'Not Implemented'! !

!CMCondenser methodsFor: 'as yet unclassified' stamp: 'toma 2/8/2016 11:46'!
acceptPragmaNode: aNode
	self inside: 'pragma' do: [
		super acceptPragmaNode: aNode]! !

!CMCondenser methodsFor: 'as yet unclassified' stamp: 'toma 2/8/2016 11:46'!
acceptReturnNode: aNode
	self inside: 'return' do: [
		super acceptReturnNode: aNode]! !

!CMCondenser methodsFor: 'as yet unclassified' stamp: 'toma 2/8/2016 11:46'!
acceptSequenceNode: aNode
	self inside: 'sequence' do: [
		aNode temporaries ifNotEmpty: [
			self inside: 'args' do: [
				self visitArguments: aNode temporaries]].
		self inside: 'statements' do: [
			aNode statements do: [:each | self visitNode: each]]].! !

!CMCondenser methodsFor: 'as yet unclassified' stamp: 'toma 2/8/2016 11:46'!
acceptVariableNode: aNode
		self text: aNode name asString tagged: 'variable'! !

!CMCondenser methodsFor: 'as yet unclassified' stamp: 'toma 2/8/2016 11:46'!
closeTag
	| name |
	name := tagStack pop.
	
	(1 to: (tagStack size)) do: [ :i | self stream nextPutAll: '  '].	
	self stream nextPutAll:'</';
		nextPutAll: name;
		nextPutAll: '>', Character cr, Character lf.! !

!CMCondenser methodsFor: 'as yet unclassified' stamp: 'toma 2/8/2016 11:46'!
escape: aString
	(1 to: (aString size)) do: [ :index | | c |
		c := aString at: index.
		c := translation at: c ifAbsent: c.
		self stream nextPutAll: c	asString]! !

!CMCondenser methodsFor: 'as yet unclassified' stamp: 'toma 2/8/2016 11:46'!
exportCategories: aList

	self inside: 'categories' do: [
		aList do: [ :item | 
			self exportCategory: item excluding: [:x | false]]]
	
	! !

!CMCondenser methodsFor: 'as yet unclassified' stamp: 'toma 2/8/2016 11:46'!
exportCategory: aString excluding: aBlock

	self inside: 'category'
		with: {'prefix' -> aString}
		do: [self scanCategory: aString excluding: aBlock].! !

!CMCondenser methodsFor: 'as yet unclassified' stamp: 'toma 2/8/2016 11:46'!
exportClass: aClass
	
	self inside: 'class'
		with: {'name' -> aClass name}
		do: [self scanClass: aClass].! !

!CMCondenser methodsFor: 'as yet unclassified' stamp: 'toma 2/8/2016 11:46'!
initialize

	super initialize.
	
	tagStack := Stack new.
	translation := Dictionary new.
	translation
		at: Character cr put: '&#13;';
		at: Character lf put: '&#10;';
		at: Character tab put: '&#9;';
		at: $& put: '&amp;';
		at: $< put: '&lt;';
		at: $> put: '&gt;';
		at: $' put: '&apos;'; 
		at: $" put: '&quot;'.
	! !

!CMCondenser methodsFor: 'as yet unclassified' stamp: 'toma 2/8/2016 11:46'!
inside: aTagName do: aBlock

	self inside: aTagName with: nil do: aBlock.! !

!CMCondenser methodsFor: 'as yet unclassified' stamp: 'toma 2/8/2016 11:46'!
inside: aTagName with: anArgsDict do: aBlock

	(anArgsDict isNil) ifTrue: [
		self openTag: aTagName.]
	ifFalse: [
		self openTag: aTagName withArgs: anArgsDict].
	aBlock value.
	self closeTag.! !

!CMCondenser methodsFor: 'as yet unclassified' stamp: 'toma 2/8/2016 11:46'!
openTag: aName
	
	(1 to: (tagStack size)) do: [ :i | self stream nextPutAll: '  '].	
	(self stream) 
		nextPut: $< ;
		nextPutAll: aName;
		nextPutAll: '>', Character cr, Character lf.
		
	tagStack push: aName.! !

!CMCondenser methodsFor: 'as yet unclassified' stamp: 'toma 2/8/2016 11:46'!
openTag: aName withArgs: aDictionary

	(1 to: (tagStack size)) do: [ :i | self stream nextPutAll: '  '].	
	self stream nextPut: $< ;
		nextPutAll: aName.
		
	(Dictionary newFrom: aDictionary) keysAndValuesDo: [ :key :value |
		self stream 
			nextPut: $ ;
			nextPutAll: key;
			nextPutAll: '="'.
		self escape: value.
		self stream nextPutAll: '"'].
		
	self stream nextPutAll:  '>', Character cr, Character lf.
		
	tagStack push: aName.! !

!CMCondenser methodsFor: 'as yet unclassified' stamp: 'toma 2/8/2016 11:46'!
scanCategory: aString excluding: aBlock

	((Object allSubclasses
		select: [ :class |
			class category ifNil: [false] ifNotNilDo: [:cat | cat beginsWith: aString]])
		select: [ :class |
			(aBlock value: class) not]) 
		do: [: class |
			self exportClass: class].! !

!CMCondenser methodsFor: 'as yet unclassified' stamp: 'toma 2/8/2016 11:46'!
scanClass: aClass

	aClass methodDict valuesDo: [ :method | 	| node |
		node := RBParser parseMethod: (method getSource asString).
		self visitNode: node.
	]! !

!CMCondenser methodsFor: 'accessing' stamp: 'toma 2/8/2016 11:46'!
stream

	^ stream! !

!CMCondenser methodsFor: 'accessing' stamp: 'toma 2/8/2016 11:46'!
stream: anObject

	stream := anObject! !

!CMCondenser methodsFor: 'accessing' stamp: 'toma 2/8/2016 11:46'!
tagStack

	^ tagStack! !

!CMCondenser methodsFor: 'accessing' stamp: 'toma 2/8/2016 11:46'!
tagStack: anObject

	tagStack := anObject! !

!CMCondenser methodsFor: 'as yet unclassified' stamp: 'toma 2/8/2016 11:46'!
text: aString

	(1 to: (tagStack size)) do: [ :i | self stream nextPutAll: '  '].	
	self escape: aString.
	(self stream)
		nextPut: Character cr;
		nextPut: Character lf.! !

!CMCondenser methodsFor: 'as yet unclassified' stamp: 'toma 2/8/2016 11:46'!
text: aString tagged: aTagName

	(1 to: (tagStack size)) do: [ :i | self stream nextPutAll: '  '].	
	self stream nextPutAll: '<', aTagName, '>'.
	self escape: aString.
	self stream nextPutAll: '</', aTagName, '>', Character cr, Character lf.! !

RBProgramNodeVisitor subclass: #CMExtractor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeMine'!

!CMExtractor methodsFor: 'as yet unclassified' stamp: 'toma 2/2/2016 15:48'!
acceptMethodNode: aNode
	
	! !

RBProgramNodeVisitor subclass: #CMLSimpleMiner
	instanceVariableNames: 'model nodestack'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeMine-LanguageModel'!

!CMLSimpleMiner methodsFor: 'accessing' stamp: 'toma 2/8/2016 15:58'!
acceptArrayNode: aNode

	^(CMLArray new)
		values: (aNode children collect: [ :each | self visitNode: each]);
		yourself
	! !

!CMLSimpleMiner methodsFor: 'accessing' stamp: 'toma 2/8/2016 15:50'!
mine: anAst
	
	self visitNode: anAst.! !

!CMLSimpleMiner methodsFor: 'accessing' stamp: 'toma 2/8/2016 15:49'!
model

	^ model! !

!CMLSimpleMiner methodsFor: 'accessing' stamp: 'toma 2/8/2016 15:49'!
model: anObject

	model := anObject! !

!CMLSimpleMiner methodsFor: 'accessing' stamp: 'toma 2/8/2016 15:49'!
nodestack

	^ nodestack! !

!CMLSimpleMiner methodsFor: 'accessing' stamp: 'toma 2/8/2016 15:49'!
nodestack: anObject

	nodestack := anObject! !

RBProgramNodeVisitor subclass: #CMLTranslator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeMine-LanguageModel'!

!CMLTranslator methodsFor: 'as yet unclassified' stamp: 'toma 2/16/2016 13:07'!
acceptArrayNode: anArrayNode
	| array |
	
	array := CMLArray new.
	array
		expressions: (anArrayNode children collect: [ :each | 
			self visit: each parent: array role: #item]).
	^array! !

!CMLTranslator methodsFor: 'as yet unclassified' stamp: 'toma 2/16/2016 14:21'!
acceptAssignmentNode: anAssignmentNode 
	| assignment |
	
	assignment := CMLAssignment new.
	assignment
		variable: (self visit: anAssignmentNode variable parent: assignment role: #variable);
		expression: (self visit: anAssignmentNode value parent: assignment role: #value).
						
	^assignment
		! !

!CMLTranslator methodsFor: 'as yet unclassified' stamp: 'toma 2/16/2016 13:46'!
acceptBlockNode: aBlockNode
	| block |
	
	block := CMLBlock new.
	block
		args: (aBlockNode arguments collect: [:arg | arg name]);
		expression: (self visit: aBlockNode body parent: block role: #expression).
	^block
		
	! !

!CMLTranslator methodsFor: 'as yet unclassified' stamp: 'toma 2/16/2016 13:46'!
acceptCascadeNode: aCascadeNode 
	| cascade |
	
	cascade := CMLCascade new.
	cascade
		statements: (aCascadeNode messages collect: [:each | 
			self visit: each parent: cascade role: #child]).
	^cascade! !

!CMLTranslator methodsFor: 'as yet unclassified' stamp: 'toma 2/16/2016 13:14'!
acceptLiteralArrayNode: aRBLiteralArrayNode 
	| litarray |
	
	litarray := CMLLiteralArray new.
	litarray values: (aRBLiteralArrayNode contents collect: [:each | 
		self visit: each parent: litarray role: #item]).
	^litarray! !

!CMLTranslator methodsFor: 'as yet unclassified' stamp: 'toma 2/15/2016 16:57'!
acceptLiteralNode: aLiteralNode

	^(CMLLiteral new)
		value: (aLiteralNode value);
		yourself! !

!CMLTranslator methodsFor: 'as yet unclassified' stamp: 'toma 2/16/2016 14:37'!
acceptMessageNode: aMessageNode 
	| message |
	message := CMLMessage new.
	message
		receiver: (self visit: aMessageNode receiver parent: message role: #receiver);
		selector: (aMessageNode selector);
		selectorParts: (aMessageNode selectorParts collect: [:each | each value]);
		args:	(aMessageNode arguments collect: [:each | 
					self visit: each parent: message role: #argument]).
	^message
	! !

!CMLTranslator methodsFor: 'as yet unclassified' stamp: 'toma 2/16/2016 14:36'!
acceptMethodNode: aMethodNode 

	| method |
	
	method := CMLMethod new.
	method
		selector: (aMethodNode selector);
		selectorParts: (aMethodNode selectorParts collect: [:each | each value]);
		argnames: (aMethodNode arguments collect: [ :each | each name ]);
		body: (self visit: aMethodNode body parent: method role: #body).
	^method! !

!CMLTranslator methodsFor: 'as yet unclassified' stamp: 'toma 2/16/2016 13:40'!
acceptPatternBlockNode: aRBPatternBlockNode 
	self error: 'Pattern Blocks not supported'
	! !

!CMLTranslator methodsFor: 'as yet unclassified' stamp: 'toma 2/16/2016 13:40'!
acceptPatternWrapperBlockNode: aRBPatternWrapperBlockNode 
	self error: 'Pattern Blocks not supported'
	! !

!CMLTranslator methodsFor: 'as yet unclassified' stamp: 'toma 2/16/2016 13:41'!
acceptPragmaNode: aPragmaNode 
	
	! !

!CMLTranslator methodsFor: 'as yet unclassified' stamp: 'toma 2/16/2016 13:42'!
acceptReturnNode: aReturnNode 
	| ret |
	ret := CMLReturn new.
	ret expression: [self visit: aReturnNode value parent: ret role: #expression].
	^ret
	! !

!CMLTranslator methodsFor: 'as yet unclassified' stamp: 'toma 2/16/2016 13:44'!
acceptSequenceNode: aSequenceNode 
	| sequence |
	sequence := CMLSequence new.
	
	sequence
		variables: (aSequenceNode temporaries collect: [:each | each name]);
		statements: (aSequenceNode statements collect: [:each |
			self visit: each parent: sequence role: #child]).
	^sequence! !

!CMLTranslator methodsFor: 'as yet unclassified' stamp: 'toma 2/16/2016 13:45'!
acceptVariableNode: aVariableNode

	| var |
	var := CMLVariable new.
	var name: aVariableNode name.
	^var! !

!CMLTranslator methodsFor: 'accessing' stamp: 'toma 2/15/2016 16:58'!
cascadeReceiver

	^ cascadeReceiver! !

!CMLTranslator methodsFor: 'accessing' stamp: 'toma 2/15/2016 16:58'!
cascadeReceiver: anObject

	cascadeReceiver := anObject! !

!CMLTranslator methodsFor: 'accessing' stamp: 'toma 2/8/2016 17:11'!
collector

	^ collector! !

!CMLTranslator methodsFor: 'accessing' stamp: 'toma 2/8/2016 17:11'!
collector: anObject

	collector := anObject! !

!CMLTranslator methodsFor: 'as yet unclassified' stamp: 'toma 2/8/2016 16:00'!
translate: anAST

	^self visitNode: anAST! !

!CMLTranslator methodsFor: 'as yet unclassified' stamp: 'toma 2/16/2016 14:25'!
translateCategory: aPrefix

	| category |
	category := CMLCategory new.
	category
		name: aPrefix;
		classes: ((Object allSubclasses
						select: [ :class |
							class category
								ifNil: [false] 
								ifNotNilDo: [:cat | cat beginsWith: aPrefix]])
						collect: [ :class | 
							(self translateClass: class)
								parent: category;
								yourself]).
	^category! !

!CMLTranslator methodsFor: 'as yet unclassified' stamp: 'toma 2/16/2016 13:58'!
translateClass: aClass
	| cls |
	cls := CMLClass new.
	cls name: (aClass name).
	aClass methodDict valuesDo: [ :method | 	| node |
		node := self translateMethod: method.
		node
			parent: cls;
			role: #method.
		cls methods at: node selector put: node].
	^cls! !

!CMLTranslator methodsFor: 'as yet unclassified' stamp: 'toma 2/16/2016 13:50'!
translateMethod: aMethod

	^self translate: (RBParser parseMethod: (aMethod getSource asString))! !

!CMLTranslator methodsFor: 'as yet unclassified' stamp: 'toma 2/16/2016 13:06'!
visit: aNode parent: anotherNode role: aSymbol
	^(self visitNode: aNode)
			parent: anotherNode;
			role: aSymbol;
			yourself.! !

RBProgramNodeVisitor subclass: #CMMethodSelectorCrawler
	instanceVariableNames: 'currentMethod currentClass selectors methods'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeMine-CallGraph'!

!CMMethodSelectorCrawler methodsFor: 'as yet unclassified' stamp: 'toma 5/24/2016 17:14'!
acceptMessageNode: aMessageNode

	| selector |

	selector := self selectorFor: aMessageNode selector.
	self currentMethod addCallTo: selector.
	super acceptMessageNode: aMessageNode.

	! !

!CMMethodSelectorCrawler methodsFor: 'as yet unclassified' stamp: 'toma 5/26/2016 18:22'!
acceptMethodNode: aMethodNode

	| selector method |
	
	selector := self selectorFor: aMethodNode selector asSymbol.
	method := (self createMethodForSelector: selector).
	method className: self currentClass name.
	selector addImplementor: method.
	self currentMethod: method.
	self methods add: method.
	super acceptMethodNode: aMethodNode
	! !

!CMMethodSelectorCrawler methodsFor: 'as yet unclassified' stamp: 'toma 5/24/2016 17:02'!
createMethodForSelector: aSelector

	^CMMethodNode new selector: aSelector! !

!CMMethodSelectorCrawler methodsFor: 'as yet unclassified' stamp: 'toma 5/24/2016 17:13'!
createSelectorNamed: aSymbol

	"overridable factory method"
	^CMSelectorNode new symbol: aSymbol
	! !

!CMMethodSelectorCrawler methodsFor: 'accessing' stamp: 'toma 5/26/2016 18:22'!
currentClass

	^ currentClass! !

!CMMethodSelectorCrawler methodsFor: 'accessing' stamp: 'toma 5/26/2016 18:22'!
currentClass: anObject

	currentClass := anObject! !

!CMMethodSelectorCrawler methodsFor: 'accessing' stamp: 'toma 5/24/2016 16:54'!
currentMethod

	^ currentMethod! !

!CMMethodSelectorCrawler methodsFor: 'accessing' stamp: 'toma 5/24/2016 16:54'!
currentMethod: anObject

	currentMethod := anObject! !

!CMMethodSelectorCrawler methodsFor: 'as yet unclassified' stamp: 'toma 5/26/2016 14:33'!
getGraph
	self reIndex.
	^(CMMethodSelectorGraph new)
		selectors: self selectors;
		methods: self methods;
		yourself
	! !

!CMMethodSelectorCrawler methodsFor: 'as yet unclassified' stamp: 'toma 5/24/2016 16:58'!
initialize
	self
		methods: OrderedCollection new;
		selectors: Dictionary new! !

!CMMethodSelectorCrawler methodsFor: 'accessing' stamp: 'toma 5/24/2016 16:54'!
methods

	^ methods! !

!CMMethodSelectorCrawler methodsFor: 'accessing' stamp: 'toma 5/24/2016 16:54'!
methods: anObject

	methods := anObject! !

!CMMethodSelectorCrawler methodsFor: 'as yet unclassified' stamp: 'toma 5/26/2016 14:55'!
reIndex
	| initialPageRank |
	initialPageRank := 1.0 / (self selectors size + self methods size).
	
	self selectors values withIndexDo: [:selector :index |
		selector
			index: index;
			pageRank: initialPageRank].
	self methods withIndexDo: [:method :index |
		method
			index: index;
			pageRank: initialPageRank]
	! !

!CMMethodSelectorCrawler methodsFor: 'as yet unclassified' stamp: 'toma 5/24/2016 17:10'!
scanCategoryPrefix: aString

	self scanCategoryPrefix: aString excluding: [:class | false].! !

!CMMethodSelectorCrawler methodsFor: 'as yet unclassified' stamp: 'toma 5/24/2016 16:47'!
scanCategoryPrefix: aString excluding: aBlock

	((Object allSubclasses
		select: [ :class |
			class category ifNil: [false] ifNotNilDo: [:cat | cat beginsWith: aString]])
		select: [ :class |
			(aBlock value: class) not]) 
		do: [: class |
			self scanClass: class].
! !

!CMMethodSelectorCrawler methodsFor: 'as yet unclassified' stamp: 'toma 5/26/2016 18:22'!
scanClass: aClass

	self currentClass: aClass.
	aClass methodDict valuesDo: [ :method | 
		self scanMethod: method ]! !

!CMMethodSelectorCrawler methodsFor: 'as yet unclassified' stamp: 'toma 5/24/2016 16:50'!
scanMethod: aMethod
	
	| node |
	
	node := RBParser parseMethod: (aMethod getSource asString).
	self visitNode: node.! !

!CMMethodSelectorCrawler methodsFor: 'as yet unclassified' stamp: 'toma 5/24/2016 17:17'!
selectorFor: aSymbol

	^self selectors
		at: aSymbol 
		ifAbsentPut: [ self createSelectorNamed: aSymbol ]
	! !

!CMMethodSelectorCrawler methodsFor: 'accessing' stamp: 'toma 5/24/2016 16:54'!
selectors

	^ selectors! !

!CMMethodSelectorCrawler methodsFor: 'accessing' stamp: 'toma 5/24/2016 16:54'!
selectors: anObject

	selectors := anObject! !

RBProgramNodeVisitor subclass: #CMTextVisitor
	instanceVariableNames: 'literals onSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeMine-Text'!

!CMTextVisitor class methodsFor: 'as yet unclassified' stamp: 'toma 8/12/2015 23:18'!
normalize: aString
	"Splits a camel case selector into lowercase atoms without colons"
	
	| tokens lastIndex string |

	string := aString.
	tokens := OrderedCollection new.
	lastIndex := 1.
	string withIndexDo: [ :char :index |
		(char isUppercase or: [char isLetter not]) ifTrue: [
			(index > 1) ifTrue: [
				tokens add: (string copyFrom: lastIndex to: (index - 1)) asLowercase.
			].
			lastIndex := index.
		]
	].
	(lastIndex <= (string size)) ifTrue: [
		tokens add: (string copyFrom: lastIndex to: (string size)) asLowercase.
	].
	^(tokens collect: [:token | token onlyLetters]) select: [:token | token size >= 3]! !

!CMTextVisitor methodsFor: 'as yet unclassified' stamp: 'toma 8/12/2015 22:26'!
acceptLiteralNode: aLiteralNode
	| value |
	super acceptLiteralNode: aLiteralNode.
	value := aLiteralNode token value.
	(value isString)
		ifTrue: [(CMTextVisitor normalize: value) do: [:atom | self literals add: atom]]
	! !

!CMTextVisitor methodsFor: 'as yet unclassified' stamp: 'toma 8/18/2015 18:25'!
acceptMessageNode: aMessageNode 
	
	super acceptMessageNode: aMessageNode.
	(CMTextVisitor normalize: (aMessageNode selector)) do: [ :atom |
		self literals add: atom.
		self onSelector value: (self literals size) value: (aMessageNode selector)].
	self literals add: (aMessageNode selector)! !

!CMTextVisitor methodsFor: 'as yet unclassified' stamp: 'toma 8/12/2015 22:26'!
acceptMethodNode: aMethodNode
	
	super acceptMethodNode: aMethodNode.
	(CMTextVisitor normalize: (aMethodNode selector)) do: [ :atom |
		self literals add: atom]! !

!CMTextVisitor methodsFor: 'as yet unclassified' stamp: 'toma 8/12/2015 22:26'!
acceptVariableNode: aVariableNode

	super acceptVariableNode: aVariableNode.
	(CMTextVisitor normalize: (aVariableNode name)) do: [ :atom |
		self literals add: atom]
	! !

!CMTextVisitor methodsFor: 'as yet unclassified' stamp: 'toma 8/12/2015 21:36'!
initialize 

	super initialize.
	literals := OrderedCollection new.! !

!CMTextVisitor methodsFor: 'accessing' stamp: 'toma 8/12/2015 21:38'!
literals
	^ literals! !

!CMTextVisitor methodsFor: 'accessing' stamp: 'toma 8/12/2015 21:38'!
literals: anObject
	literals := anObject! !

!CMTextVisitor methodsFor: 'accessing' stamp: 'toma 8/14/2015 16:39'!
onSelector
	^ onSelector! !

!CMTextVisitor methodsFor: 'accessing' stamp: 'toma 8/14/2015 16:39'!
onSelector: anObject
	onSelector := anObject! !

RBProgramNodeVisitor subclass: #CMTreeExporter
	instanceVariableNames: 'stream tagStack translation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeMine'!

!CMTreeExporter class methodsFor: 'as yet unclassified' stamp: 'toma 1/29/2016 18:16'!
on: aStream

	^(CMTreeExporter new)
		stream: aStream; 
		yourself! !

!CMTreeExporter methodsFor: 'as yet unclassified' stamp: 'toma 1/29/2016 16:19'!
acceptArrayNode: anArrayNode
	self inside: 'array' do: [
		super acceptArrayNode: anArrayNode]! !

!CMTreeExporter methodsFor: 'as yet unclassified' stamp: 'toma 2/1/2016 16:32'!
acceptAssignmentNode: aNode
	self inside: 'assignment' do: [
			self inside: 'to' do: [self visitNode:  aNode variable].
			self inside: 'value' do: [self visitNode: aNode value]]
			! !

!CMTreeExporter methodsFor: 'as yet unclassified' stamp: 'toma 1/29/2016 18:26'!
acceptBlockNode: aNode
	self inside: 'block' do: [
		aNode arguments ifNotEmpty: [
		self inside: 'args' do: [
			self visitArguments: aNode arguments]].
		self inside: 'body' do: [
			self visitNode: aNode body.]]! !

!CMTreeExporter methodsFor: 'as yet unclassified' stamp: 'toma 1/29/2016 16:26'!
acceptCascadeNode: aNode
	self inside: 'cascade' do: [
		super acceptCascadeNode: aNode]! !

!CMTreeExporter methodsFor: 'as yet unclassified' stamp: 'toma 1/29/2016 16:27'!
acceptLiteralArrayNode: aNode
	self inside: 'literals' do: [
		super acceptLiteralArrayNode: aNode.]	! !

!CMTreeExporter methodsFor: 'as yet unclassified' stamp: 'toma 2/1/2016 17:13'!
acceptLiteralNode: aNode
		self text: (aNode value asString) tagged: 'literal'! !

!CMTreeExporter methodsFor: 'as yet unclassified' stamp: 'toma 1/29/2016 18:48'!
acceptMessageNode: aNode
	self inside: 'message' 
	with: {'selector' -> aNode selector asString}
	do: [	
			(aNode isCascaded not or: [aNode isFirstCascaded]) 
				ifTrue: [
					self inside: 'receiver' do:  [
						self visitNode: aNode receiver]].
			aNode arguments ifNotEmpty: [
				self inside: 'args' do: [
					aNode arguments do: [
						:each | self visitNode: each]]]].! !

!CMTreeExporter methodsFor: 'as yet unclassified' stamp: 'toma 1/29/2016 18:23'!
acceptMethodNode: aNode
	self inside: 'method' 
	with: {'selector' -> aNode selector asString}
	do: [
		aNode arguments ifNotEmpty: [
			self inside: 'args' do: [
				self visitArguments: aNode arguments]].
		aNode pragmas ifNotEmpty: [
			self inside: 'pragmas' do: [
				aNode pragmas	do: [ :each | self visitNode: each ]]].
		self inside: 'body' do: [
			self visitNode: aNode body]].! !

!CMTreeExporter methodsFor: 'as yet unclassified' stamp: 'toma 1/29/2016 16:40'!
acceptPatternBlockNode: aNode
	self fail: 'Not Implemented'! !

!CMTreeExporter methodsFor: 'as yet unclassified' stamp: 'toma 1/29/2016 16:40'!
acceptPatternWrapperBlockNode: aNode
	self fail: 'Not Implemented'! !

!CMTreeExporter methodsFor: 'as yet unclassified' stamp: 'toma 1/29/2016 16:41'!
acceptPragmaNode: aNode
	self inside: 'pragma' do: [
		super acceptPragmaNode: aNode]! !

!CMTreeExporter methodsFor: 'as yet unclassified' stamp: 'toma 1/29/2016 16:41'!
acceptReturnNode: aNode
	self inside: 'return' do: [
		super acceptReturnNode: aNode]! !

!CMTreeExporter methodsFor: 'as yet unclassified' stamp: 'toma 1/29/2016 18:26'!
acceptSequenceNode: aNode
	self inside: 'sequence' do: [
		aNode temporaries ifNotEmpty: [
			self inside: 'args' do: [
				self visitArguments: aNode temporaries]].
		self inside: 'statements' do: [
			aNode statements do: [:each | self visitNode: each]]].! !

!CMTreeExporter methodsFor: 'as yet unclassified' stamp: 'toma 2/1/2016 16:36'!
acceptVariableNode: aNode
		self text: aNode name asString tagged: 'variable'! !

!CMTreeExporter methodsFor: 'as yet unclassified' stamp: 'toma 1/29/2016 18:32'!
closeTag
	| name |
	name := tagStack pop.
	
	(1 to: (tagStack size)) do: [ :i | self stream nextPutAll: '  '].	
	self stream nextPutAll:'</';
		nextPutAll: name;
		nextPutAll: '>', Character cr, Character lf.! !

!CMTreeExporter methodsFor: 'as yet unclassified' stamp: 'toma 2/1/2016 17:04'!
escape: aString
	(1 to: (aString size)) do: [ :index | | c |
		c := aString at: index.
		c := translation at: c ifAbsent: c.
		self stream nextPutAll: c	asString]! !

!CMTreeExporter methodsFor: 'as yet unclassified' stamp: 'toma 2/1/2016 17:27'!
exportCategories: aList

	self inside: 'categories' do: [
		aList do: [ :item | 
			self exportCategory: item excluding: [:x | false]]]
	
	! !

!CMTreeExporter methodsFor: 'as yet unclassified' stamp: 'toma 1/29/2016 18:15'!
exportCategory: aString excluding: aBlock

	self inside: 'category'
		with: {'prefix' -> aString}
		do: [self scanCategory: aString excluding: aBlock].! !

!CMTreeExporter methodsFor: 'as yet unclassified' stamp: 'toma 1/29/2016 18:12'!
exportClass: aClass
	
	self inside: 'class'
		with: {'name' -> aClass name}
		do: [self scanClass: aClass].! !

!CMTreeExporter methodsFor: 'as yet unclassified' stamp: 'toma 2/1/2016 17:01'!
initialize

	super initialize.
	
	tagStack := Stack new.
	translation := Dictionary new.
	translation
		at: Character cr put: '&#13;';
		at: Character lf put: '&#10;';
		at: Character tab put: '&#9;';
		at: $& put: '&amp;';
		at: $< put: '&lt;';
		at: $> put: '&gt;';
		at: $' put: '&apos;'; 
		at: $" put: '&quot;'.
	! !

!CMTreeExporter methodsFor: 'as yet unclassified' stamp: 'toma 1/29/2016 16:19'!
inside: aTagName do: aBlock

	self inside: aTagName with: nil do: aBlock.! !

!CMTreeExporter methodsFor: 'as yet unclassified' stamp: 'toma 1/29/2016 16:18'!
inside: aTagName with: anArgsDict do: aBlock

	(anArgsDict isNil) ifTrue: [
		self openTag: aTagName.]
	ifFalse: [
		self openTag: aTagName withArgs: anArgsDict].
	aBlock value.
	self closeTag.! !

!CMTreeExporter methodsFor: 'as yet unclassified' stamp: 'toma 1/29/2016 18:32'!
openTag: aName
	
	(1 to: (tagStack size)) do: [ :i | self stream nextPutAll: '  '].	
	(self stream) 
		nextPut: $< ;
		nextPutAll: aName;
		nextPutAll: '>', Character cr, Character lf.
		
	tagStack push: aName.! !

!CMTreeExporter methodsFor: 'as yet unclassified' stamp: 'toma 2/1/2016 17:10'!
openTag: aName withArgs: aDictionary

	(1 to: (tagStack size)) do: [ :i | self stream nextPutAll: '  '].	
	self stream nextPut: $< ;
		nextPutAll: aName.
		
	(Dictionary newFrom: aDictionary) keysAndValuesDo: [ :key :value |
		self stream 
			nextPut: $ ;
			nextPutAll: key;
			nextPutAll: '="'.
		self escape: value.
		self stream nextPutAll: '"'].
		
	self stream nextPutAll:  '>', Character cr, Character lf.
		
	tagStack push: aName.! !

!CMTreeExporter methodsFor: 'as yet unclassified' stamp: 'toma 1/29/2016 18:13'!
scanCategory: aString excluding: aBlock

	((Object allSubclasses
		select: [ :class |
			class category ifNil: [false] ifNotNilDo: [:cat | cat beginsWith: aString]])
		select: [ :class |
			(aBlock value: class) not]) 
		do: [: class |
			self exportClass: class].! !

!CMTreeExporter methodsFor: 'as yet unclassified' stamp: 'toma 1/29/2016 18:11'!
scanClass: aClass

	aClass methodDict valuesDo: [ :method | 	| node |
		node := RBParser parseMethod: (method getSource asString).
		self visitNode: node.
	]! !

!CMTreeExporter methodsFor: 'accessing' stamp: 'toma 1/29/2016 16:08'!
stream

	^ stream! !

!CMTreeExporter methodsFor: 'accessing' stamp: 'toma 1/29/2016 16:08'!
stream: anObject

	stream := anObject! !

!CMTreeExporter methodsFor: 'accessing' stamp: 'toma 1/29/2016 16:08'!
tagStack

	^ tagStack! !

!CMTreeExporter methodsFor: 'accessing' stamp: 'toma 1/29/2016 16:08'!
tagStack: anObject

	tagStack := anObject! !

!CMTreeExporter methodsFor: 'as yet unclassified' stamp: 'toma 2/1/2016 17:03'!
text: aString

	(1 to: (tagStack size)) do: [ :i | self stream nextPutAll: '  '].	
	self escape: aString.
	(self stream)
		nextPut: Character cr;
		nextPut: Character lf.! !

!CMTreeExporter methodsFor: 'as yet unclassified' stamp: 'toma 2/1/2016 16:59'!
text: aString tagged: aTagName

	(1 to: (tagStack size)) do: [ :i | self stream nextPutAll: '  '].	
	self stream nextPutAll: '<', aTagName, '>'.
	self escape: aString.
	self stream nextPutAll: '</', aTagName, '>', Character cr, Character lf.! !

RBProgramNodeVisitor subclass: #CmTracer
	instanceVariableNames: 'context'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeMine-Tracing'!

!CmTracer methodsFor: 'as yet unclassified' stamp: 'toma 5/13/2016 12:59'!
acceptMessageNode: aMessageNode 
	| operation |
	operation := CmTraceOperation new.! !

!CmTracer methodsFor: 'accessing' stamp: 'toma 5/13/2016 12:58'!
context

	^ context! !

!CmTracer methodsFor: 'accessing' stamp: 'toma 5/13/2016 12:58'!
context: anObject

	context := anObject! !

!CmTracer methodsFor: 'as yet unclassified' stamp: 'toma 5/13/2016 12:58'!
initialize
	self context: CmTracingContext new.! !

StringMorph subclass: #CUIProjectedItemLabel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeMine-UI'!

Object subclass: #CMCallGraph
	instanceVariableNames: 'selectorsMap methods'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeMine'!

!CMCallGraph class methodsFor: 'as yet unclassified' stamp: 'toma 8/12/2015 20:32'!
fromCategory: aString
	"Compute call graph from categories beginning with aString"

	| callGraph |
	
	callGraph := CMCallGraph new.
	(CMCallGraphBuilder forGraph: callGraph) scanCategoryPrefix: aString.
	^callGraph! !

!CMCallGraph class methodsFor: 'as yet unclassified' stamp: 'toma 8/13/2015 15:09'!
fromCategory: aString excluding: aBlock
	"Compute call graph from categories beginning with aString"

	| callGraph |
	
	callGraph := CMCallGraph new.
	(CMCallGraphBuilder forGraph: callGraph) scanCategoryPrefix: aString excluding: aBlock.
	^callGraph! !

!CMCallGraph methodsFor: 'as yet unclassified' stamp: 'toma 8/12/2015 17:54'!
addMethod: aCMMethod
	methods add: aCMMethod
	
	! !

!CMCallGraph methodsFor: 'as yet unclassified' stamp: 'toma 8/12/2015 17:07'!
initialize 
	super initialize.
	selectorsMap := Dictionary new.
	methods := OrderedCollection new.! !

!CMCallGraph methodsFor: 'accessing' stamp: 'toma 8/12/2015 17:08'!
methods
	^ methods! !

!CMCallGraph methodsFor: 'accessing' stamp: 'toma 8/12/2015 17:08'!
methods: anObject
	methods := anObject! !

!CMCallGraph methodsFor: 'as yet unclassified' stamp: 'toma 8/12/2015 17:14'!
selectorFor: aSymbol
	
	^selectorsMap
		at: aSymbol 
		ifAbsentPut: [ CMSelector named: aSymbol ]! !

!CMCallGraph methodsFor: 'accessing' stamp: 'toma 8/12/2015 17:08'!
selectorsMap
	^ selectorsMap! !

!CMCallGraph methodsFor: 'accessing' stamp: 'toma 8/12/2015 17:08'!
selectorsMap: anObject
	selectorsMap := anObject! !

Object subclass: #CMCallingRelation
	instanceVariableNames: 'previous next container selector backwardDeps forwardDeps'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeMine'!

!CMCallingRelation methodsFor: 'accessing' stamp: 'toma 8/17/2015 14:31'!
backwardDeps
	^ backwardDeps! !

!CMCallingRelation methodsFor: 'accessing' stamp: 'toma 8/17/2015 14:31'!
backwardDeps: anObject
	backwardDeps := anObject! !

!CMCallingRelation methodsFor: 'accessing' stamp: 'toma 8/12/2015 17:08'!
container
	^ container! !

!CMCallingRelation methodsFor: 'accessing' stamp: 'toma 8/12/2015 17:08'!
container: anObject
	container := anObject! !

!CMCallingRelation methodsFor: 'accessing' stamp: 'toma 8/17/2015 14:31'!
forwardDeps
	^ forwardDeps! !

!CMCallingRelation methodsFor: 'accessing' stamp: 'toma 8/17/2015 14:31'!
forwardDeps: anObject
	forwardDeps := anObject! !

!CMCallingRelation methodsFor: 'as yet unclassified' stamp: 'toma 8/17/2015 14:32'!
initialize

	backwardDeps := OrderedCollection new.
	forwardDeps := OrderedCollection new.! !

!CMCallingRelation methodsFor: 'accessing' stamp: 'toma 8/12/2015 17:08'!
selector
	^ selector! !

!CMCallingRelation methodsFor: 'accessing' stamp: 'toma 8/12/2015 17:08'!
selector: anObject
	selector := anObject! !

Object subclass: #CMCodeTopicModel
	instanceVariableNames: 'methodTexts featureSpace topicModel linkField'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeMine-Text'!

!CMCodeTopicModel methodsFor: 'as yet unclassified' stamp: 'toma 8/14/2015 18:42'!
computeLinkedTopics: numTopics forIterations: iterations
	
	| lda |

	lda := LDLinkedAllocator new.
	lda linkField: linkField;
		contextWeight: 0.3;
		featurePriors: (self featureSpace estimateFeaturePriors).
	
	self topicModel: (lda
		allocate: (self methodTexts values) 
		iterating: iterations 
		features: (self featureSpace featureCount) 
		topics: numTopics).
	^self topicModel
	
	! !

!CMCodeTopicModel methodsFor: 'as yet unclassified' stamp: 'toma 8/12/2015 22:41'!
computeTopics: numTopics forIterations: iterations
	
	| lda |

	lda := LDAllocator new.
	self topicModel: (lda
		allocate: (self methodTexts values) 
		iterating: iterations 
		features: (self featureSpace featureCount) 
		topics: numTopics).
	^self topicModel
	
	! !

!CMCodeTopicModel methodsFor: 'as yet unclassified' stamp: 'toma 8/14/2015 17:38'!
extractTextFromCallGraph: aCallGraph
	"Collect all textual tokens from a call graph, eliminate non-frequent tokens
	and construct the feature space from the rest"

	| frequencies methodFeatures dependencies selectorMapping docId |
	frequencies := Dictionary new.
	methodFeatures := OrderedDictionary new.
	dependencies := Dictionary new.
	selectorMapping := Dictionary new.

	docId := 1.
	
	aCallGraph methods do: [ :method | | textVisitor currentSelector |
		currentSelector := method implementedSelector symbol.
		selectorMapping at: currentSelector ifAbsentPut: [OrderedCollection new].
		(selectorMapping at: currentSelector) add: docId.
			
		textVisitor := CMTextVisitor new.
		textVisitor onSelector: [ :position :targetSelector | 
			dependencies at: (docId @ position) put: targetSelector.
		].

		textVisitor visitNode: (method sourceTree).
		textVisitor literals do: [ :symbol |
			frequencies at: symbol put: (1 + (frequencies at: symbol ifAbsentPut: 0)).
		].
		methodFeatures at: method put: (textVisitor literals).
		docId := docId + 1.
	].

	methodFeatures keysAndValuesDo: [ :method :features | | reducedFeatures |
		reducedFeatures := features select: [:feature | (frequencies at: feature) > 2 ].
		self methodTexts
			at: method 
			put: (self featureSpace representAll: reducedFeatures).
		].

	"Unwrap 
		(d @ w) -> #selector
	and
		#selector -> d1, dw, ...
	to
		(d @ w) -> d1, d2, ..."

	linkField := LDLinkField new.
	dependencies keysAndValuesDo: [ :position :targetSelector |
		selectorMapping at: targetSelector ifPresent: [ :targetIds |
			targetIds do: [ :id |  linkField linkDocument: (position x) at: (position y) to: id ]]].! !

!CMCodeTopicModel methodsFor: 'accessing' stamp: 'toma 8/12/2015 22:34'!
featureSpace
	^ featureSpace! !

!CMCodeTopicModel methodsFor: 'accessing' stamp: 'toma 8/12/2015 22:34'!
featureSpace: anObject
	featureSpace := anObject! !

!CMCodeTopicModel methodsFor: 'as yet unclassified' stamp: 'toma 8/14/2015 18:42'!
initialize 
	
	methodTexts := OrderedDictionary new.
	featureSpace := LDDocumentFeatureSpace new.! !

!CMCodeTopicModel methodsFor: 'accessing' stamp: 'toma 8/12/2015 22:30'!
methodTexts
	^ methodTexts! !

!CMCodeTopicModel methodsFor: 'accessing' stamp: 'toma 8/12/2015 22:30'!
methodTexts: anObject
	methodTexts := anObject! !

!CMCodeTopicModel methodsFor: 'as yet unclassified' stamp: 'toma 8/12/2015 22:53'!
sortedTopic: topic
	
	^(((self topicModel featuresForTopicAt: topic) 
		withIndexCollect: [ :value :index | 
			Array with: value with: index]) 
		sorted: [ :a :b | (a first) > (b first) ])
		collect: [ :pair | self featureSpace interpret: (pair second) ]
	! !

!CMCodeTopicModel methodsFor: 'accessing' stamp: 'toma 8/12/2015 22:34'!
topicModel
	^ topicModel! !

!CMCodeTopicModel methodsFor: 'accessing' stamp: 'toma 8/12/2015 22:34'!
topicModel: anObject
	topicModel := anObject! !

Object subclass: #CMConceptPart
	instanceVariableNames: 'extent intent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeMine'!

Object subclass: #CMDataDependency
	instanceVariableNames: 'name definition uses'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeMine'!

CMDataDependency subclass: #CMArgumentDependency
	instanceVariableNames: 'sources'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeMine'!

!CMArgumentDependency class methodsFor: 'as yet unclassified' stamp: 'toma 8/17/2015 15:48'!
named: aString
	
	^(CMArgumentDependency new)
		name: aString;
		yourself.! !

!CMArgumentDependency methodsFor: 'as yet unclassified' stamp: 'toma 8/17/2015 15:49'!
isArgument

	^ true! !

!CMArgumentDependency methodsFor: 'accessing' stamp: 'toma 8/17/2015 15:41'!
sources
	^ sources! !

!CMArgumentDependency methodsFor: 'accessing' stamp: 'toma 8/17/2015 15:41'!
sources: anObject
	sources := anObject! !

!CMDataDependency class methodsFor: 'as yet unclassified' stamp: 'toma 8/17/2015 14:42'!
definedAt: aCallingRelation
	
	^(CMDataDependency new)
		definition: aCallingRelation;
		uses: OrderedCollection new;
		yourself.! !

!CMDataDependency class methodsFor: 'as yet unclassified' stamp: 'toma 8/17/2015 14:43'!
named: aString definedAt: aCallingRelation
	
	^(CMDataDependency new)
		definition: aCallingRelation;
		uses: OrderedCollection new;
		name: aString;
		yourself.! !

!CMDataDependency methodsFor: 'accessing' stamp: 'toma 8/17/2015 14:41'!
definition
	^ definition! !

!CMDataDependency methodsFor: 'accessing' stamp: 'toma 8/17/2015 14:41'!
definition: anObject
	definition := anObject! !

!CMDataDependency methodsFor: 'as yet unclassified' stamp: 'toma 8/17/2015 15:49'!
isArgument

	^ false! !

!CMDataDependency methodsFor: 'as yet unclassified' stamp: 'toma 8/17/2015 15:49'!
isSelf

	^ false! !

!CMDataDependency methodsFor: 'accessing' stamp: 'toma 8/17/2015 14:43'!
name
	^ name! !

!CMDataDependency methodsFor: 'accessing' stamp: 'toma 8/17/2015 14:43'!
name: anObject
	name := anObject! !

!CMDataDependency methodsFor: 'accessing' stamp: 'toma 8/17/2015 14:41'!
uses
	^ uses! !

!CMDataDependency methodsFor: 'accessing' stamp: 'toma 8/17/2015 14:41'!
uses: anObject
	uses := anObject! !

CMDataDependency subclass: #CMSelfDependency
	instanceVariableNames: 'cls'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeMine'!

!CMSelfDependency class methodsFor: 'as yet unclassified' stamp: 'toma 8/17/2015 17:22'!
newForClass: aClass

	^(CMSelfDependency new)
		cls: aClass;
		name: 'self';
		yourself! !

!CMSelfDependency methodsFor: 'accessing' stamp: 'toma 8/17/2015 15:34'!
cls
	^ cls! !

!CMSelfDependency methodsFor: 'accessing' stamp: 'toma 8/17/2015 15:35'!
cls: anObject
	cls := anObject! !

!CMSelfDependency methodsFor: 'as yet unclassified' stamp: 'toma 8/17/2015 15:49'!
isSelf

	^ true! !

Object subclass: #CMLNode
	instanceVariableNames: 'topic parent role'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeMine-LanguageModel'!

CMLNode subclass: #CMLAbstractNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeMine-LanguageModel'!

CMLAbstractNode subclass: #CMLSomeMessage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeMine-LanguageModel'!

CMLAbstractNode subclass: #CMLSomeValue
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeMine-LanguageModel'!

CMLNode subclass: #CMLCategory
	instanceVariableNames: 'name classes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeMine-LanguageModel'!

!CMLCategory methodsFor: 'accessing' stamp: 'toma 2/16/2016 14:15'!
classes

	^ classes! !

!CMLCategory methodsFor: 'accessing' stamp: 'toma 2/16/2016 14:15'!
classes: anObject

	classes := anObject! !

!CMLCategory methodsFor: 'accessing' stamp: 'toma 2/16/2016 14:15'!
name: anObject

	name := anObject! !

CMLNode subclass: #CMLClass
	instanceVariableNames: 'methods name superclass metaclass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeMine-LanguageModel'!

!CMLClass methodsFor: 'as yet unclassified' stamp: 'toma 2/16/2016 13:52'!
initialize
	
	super initialize.
	self methods: (Dictionary new)
	! !

!CMLClass methodsFor: 'accessing' stamp: 'toma 2/16/2016 13:57'!
metaclass

	^ metaclass! !

!CMLClass methodsFor: 'accessing' stamp: 'toma 2/16/2016 13:57'!
metaclass: anObject

	metaclass := anObject! !

!CMLClass methodsFor: 'accessing' stamp: 'toma 2/16/2016 13:49'!
methods

	^ methods! !

!CMLClass methodsFor: 'accessing' stamp: 'toma 2/16/2016 13:49'!
methods: anObject

	methods := anObject! !

!CMLClass methodsFor: 'accessing' stamp: 'toma 2/16/2016 13:57'!
name: anObject

	name := anObject! !

!CMLClass methodsFor: 'accessing' stamp: 'toma 2/16/2016 13:57'!
superclass

	^ superclass! !

!CMLClass methodsFor: 'accessing' stamp: 'toma 2/16/2016 13:57'!
superclass: anObject

	superclass := anObject! !

CMLNode subclass: #CMLConcreteNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeMine-LanguageModel'!

CMLConcreteNode subclass: #CMLMethod
	instanceVariableNames: 'selector argnames cls body selectorParts'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeMine-LanguageModel'!

!CMLMethod methodsFor: 'accessing' stamp: 'toma 2/15/2016 16:41'!
argnames

	^ argnames! !

!CMLMethod methodsFor: 'accessing' stamp: 'toma 2/15/2016 16:41'!
argnames: anObject

	argnames := anObject! !

!CMLMethod methodsFor: 'accessing' stamp: 'toma 2/15/2016 16:41'!
body

	^ body! !

!CMLMethod methodsFor: 'accessing' stamp: 'toma 2/15/2016 16:41'!
body: anObject

	body := anObject! !

!CMLMethod methodsFor: 'accessing' stamp: 'toma 2/15/2016 16:41'!
cls

	^ cls! !

!CMLMethod methodsFor: 'accessing' stamp: 'toma 2/15/2016 16:41'!
cls: anObject

	cls := anObject! !

!CMLMethod methodsFor: 'accessing' stamp: 'toma 2/15/2016 16:41'!
selector

	^ selector! !

!CMLMethod methodsFor: 'accessing' stamp: 'toma 2/15/2016 16:41'!
selector: anObject

	selector := anObject! !

!CMLMethod methodsFor: 'accessing' stamp: 'toma 2/16/2016 14:26'!
selectorParts

	^ selectorParts! !

!CMLMethod methodsFor: 'accessing' stamp: 'toma 2/16/2016 14:26'!
selectorParts: anObject

	selectorParts := anObject! !

CMLConcreteNode subclass: #CMLReturn
	instanceVariableNames: 'expression'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeMine-LanguageModel'!

!CMLReturn methodsFor: 'accessing' stamp: 'toma 2/15/2016 16:41'!
expression

	^ expression! !

!CMLReturn methodsFor: 'accessing' stamp: 'toma 2/15/2016 16:41'!
expression: anObject

	expression := anObject! !

CMLConcreteNode subclass: #CMLSequence
	instanceVariableNames: 'variables statements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeMine-LanguageModel'!

CMLSequence subclass: #CMLCascade
	instanceVariableNames: 'receiver'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeMine-LanguageModel'!

!CMLCascade methodsFor: 'accessing' stamp: 'toma 2/16/2016 11:53'!
receiver

	^ receiver! !

!CMLCascade methodsFor: 'accessing' stamp: 'toma 2/16/2016 11:53'!
receiver: anObject

	receiver := anObject! !

!CMLSequence methodsFor: 'accessing' stamp: 'toma 2/15/2016 16:41'!
statements

	^ statements! !

!CMLSequence methodsFor: 'accessing' stamp: 'toma 2/15/2016 16:41'!
statements: anObject

	statements := anObject! !

!CMLSequence methodsFor: 'accessing' stamp: 'toma 2/15/2016 16:41'!
variables

	^ variables! !

!CMLSequence methodsFor: 'accessing' stamp: 'toma 2/15/2016 16:41'!
variables: anObject

	variables := anObject! !

CMLConcreteNode subclass: #CMLValue
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeMine-LanguageModel'!

CMLValue subclass: #CMLArray
	instanceVariableNames: 'expressions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeMine-LanguageModel'!

!CMLArray methodsFor: 'accessing' stamp: 'toma 2/15/2016 16:42'!
expressions

	^ expressions! !

!CMLArray methodsFor: 'accessing' stamp: 'toma 2/15/2016 16:42'!
expressions: anObject

	expressions := anObject! !

CMLValue subclass: #CMLAssignment
	instanceVariableNames: 'variable expression'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeMine-LanguageModel'!

!CMLAssignment methodsFor: 'accessing' stamp: 'toma 2/15/2016 16:42'!
expression

	^ expression! !

!CMLAssignment methodsFor: 'accessing' stamp: 'toma 2/15/2016 16:42'!
expression: anObject

	expression := anObject! !

!CMLAssignment methodsFor: 'accessing' stamp: 'toma 2/15/2016 16:42'!
variable

	^ variable! !

!CMLAssignment methodsFor: 'accessing' stamp: 'toma 2/15/2016 16:42'!
variable: anObject

	variable := anObject! !

CMLValue subclass: #CMLBlock
	instanceVariableNames: 'args expression'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeMine-LanguageModel'!

!CMLBlock methodsFor: 'accessing' stamp: 'toma 2/15/2016 16:42'!
args

	^ args! !

!CMLBlock methodsFor: 'accessing' stamp: 'toma 2/15/2016 16:42'!
args: anObject

	args := anObject! !

!CMLBlock methodsFor: 'accessing' stamp: 'toma 2/16/2016 14:22'!
expression

	^ expression! !

!CMLBlock methodsFor: 'accessing' stamp: 'toma 2/16/2016 14:22'!
expression: anObject

	expression := anObject! !

CMLValue subclass: #CMLLiteral
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeMine-LanguageModel'!

!CMLLiteral methodsFor: 'accessing' stamp: 'toma 2/16/2016 14:21'!
value: anObject

	value := anObject! !

CMLLiteral subclass: #CMLLiteralArray
	instanceVariableNames: 'values'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeMine-LanguageModel'!

!CMLLiteralArray methodsFor: 'accessing' stamp: 'toma 2/15/2016 16:42'!
values

	^ values! !

!CMLLiteralArray methodsFor: 'accessing' stamp: 'toma 2/15/2016 16:42'!
values: anObject

	values := anObject! !

CMLLiteral subclass: #CMLNumber
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeMine-LanguageModel'!

CMLLiteral subclass: #CMLString
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeMine-LanguageModel'!

CMLLiteral subclass: #CMLSymbol
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeMine-LanguageModel'!

CMLValue subclass: #CMLMessage
	instanceVariableNames: 'receiver selector args selectorParts'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeMine-LanguageModel'!

!CMLMessage methodsFor: 'accessing' stamp: 'toma 2/15/2016 16:43'!
args

	^ args! !

!CMLMessage methodsFor: 'accessing' stamp: 'toma 2/15/2016 16:43'!
args: anObject

	args := anObject! !

!CMLMessage methodsFor: 'accessing' stamp: 'toma 2/15/2016 16:43'!
receiver

	^ receiver! !

!CMLMessage methodsFor: 'accessing' stamp: 'toma 2/15/2016 16:43'!
receiver: anObject

	receiver := anObject! !

!CMLMessage methodsFor: 'accessing' stamp: 'toma 2/15/2016 16:43'!
selector

	^ selector! !

!CMLMessage methodsFor: 'accessing' stamp: 'toma 2/15/2016 16:43'!
selector: anObject

	selector := anObject! !

!CMLMessage methodsFor: 'accessing' stamp: 'toma 2/16/2016 14:26'!
selectorParts

	^ selectorParts! !

!CMLMessage methodsFor: 'accessing' stamp: 'toma 2/16/2016 14:26'!
selectorParts: anObject

	selectorParts := anObject! !

CMLValue subclass: #CMLVariable
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeMine-LanguageModel'!

!CMLVariable methodsFor: 'accessing' stamp: 'toma 2/15/2016 16:43'!
name: anObject

	name := anObject! !

!CMLNode methodsFor: 'accessing' stamp: 'toma 2/15/2016 16:41'!
model

	^ model! !

!CMLNode methodsFor: 'accessing' stamp: 'toma 2/15/2016 16:41'!
model: anObject

	model := anObject! !

!CMLNode methodsFor: 'accessing' stamp: 'toma 2/15/2016 16:41'!
parent

	^ parent! !

!CMLNode methodsFor: 'accessing' stamp: 'toma 2/15/2016 16:41'!
parent: anObject

	parent := anObject! !

!CMLNode methodsFor: 'accessing' stamp: 'toma 2/16/2016 13:06'!
role

	^ role! !

!CMLNode methodsFor: 'accessing' stamp: 'toma 2/16/2016 13:06'!
role: anObject

	role := anObject! !

!CMLNode methodsFor: 'accessing' stamp: 'toma 2/15/2016 16:41'!
topic

	^ topic! !

!CMLNode methodsFor: 'accessing' stamp: 'toma 2/15/2016 16:41'!
topic: anObject

	topic := anObject! !

Object subclass: #CMLSimpleModel
	instanceVariableNames: 'instances'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeMine-LanguageModel'!

!CMLSimpleModel methodsFor: 'as yet unclassified' stamp: 'toma 2/8/2016 16:06'!
addInstance: aCMLNode
! !

!CMLSimpleModel methodsFor: 'accessing' stamp: 'toma 2/8/2016 15:45'!
instances

	^ instances! !

!CMLSimpleModel methodsFor: 'accessing' stamp: 'toma 2/8/2016 15:45'!
instances: anObject

	instances := anObject! !

Object subclass: #CMMethod
	instanceVariableNames: 'implementedSelector callingRelations sourceTree vocabulary'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeMine'!

!CMMethod methodsFor: 'accessing' stamp: 'toma 8/12/2015 17:08'!
callingRelations
	^ callingRelations! !

!CMMethod methodsFor: 'accessing' stamp: 'toma 8/12/2015 17:08'!
callingRelations: anObject
	callingRelations := anObject! !

!CMMethod methodsFor: 'accessing' stamp: 'toma 8/12/2015 17:08'!
implementedSelector
	^ implementedSelector! !

!CMMethod methodsFor: 'accessing' stamp: 'toma 8/12/2015 17:08'!
implementedSelector: anObject
	implementedSelector := anObject! !

!CMMethod methodsFor: 'as yet unclassified' stamp: 'toma 1/29/2016 14:53'!
initialize 
	super initialize.
	callingRelations := OrderedCollection new.
	vocabulary := Set new.! !

!CMMethod methodsFor: 'as yet unclassified' stamp: 'toma 8/17/2015 17:26'!
newCallTo: aSelector 

	| call |
	call := CMCallingRelation new.
	call	selector: aSelector;
		container: self.
	aSelector senders add: call.
	self callingRelations add: call.
	^call
	! !

!CMMethod methodsFor: 'accessing' stamp: 'toma 8/12/2015 20:49'!
sourceTree
	^sourceTree! !

!CMMethod methodsFor: 'accessing' stamp: 'toma 8/12/2015 21:08'!
sourceTree: aSourceAst
	sourceTree := aSourceAst! !

!CMMethod methodsFor: 'accessing' stamp: 'toma 1/29/2016 14:47'!
vocabulary

	^ vocabulary! !

!CMMethod methodsFor: 'accessing' stamp: 'toma 1/29/2016 14:47'!
vocabulary: anObject

	vocabulary := anObject! !

Object subclass: #CMMethodNode
	instanceVariableNames: 'selector className calls index pageRank oldPageRank'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeMine-CallGraph'!

!CMMethodNode methodsFor: 'as yet unclassified' stamp: 'toma 5/24/2016 17:15'!
addCallTo: aSelector
	self calls add: aSelector.
	aSelector senders add: self.! !

!CMMethodNode methodsFor: 'accessing' stamp: 'toma 5/24/2016 16:55'!
calls

	^ calls! !

!CMMethodNode methodsFor: 'accessing' stamp: 'toma 5/24/2016 16:55'!
calls: anObject

	calls := anObject! !

!CMMethodNode methodsFor: 'accessing' stamp: 'toma 5/26/2016 18:25'!
className

	^className! !

!CMMethodNode methodsFor: 'accessing' stamp: 'toma 5/26/2016 18:23'!
className: anObject

	className := anObject! !

!CMMethodNode methodsFor: 'as yet unclassified' stamp: 'toma 5/26/2016 17:03'!
inboundLinks
	^ {self selector}! !

!CMMethodNode methodsFor: 'as yet unclassified' stamp: 'toma 5/26/2016 15:32'!
indegree
	^1 "just the selector node"! !

!CMMethodNode methodsFor: 'accessing' stamp: 'toma 5/26/2016 14:32'!
index

	^ index! !

!CMMethodNode methodsFor: 'accessing' stamp: 'toma 5/26/2016 14:32'!
index: anObject

	index := anObject! !

!CMMethodNode methodsFor: 'as yet unclassified' stamp: 'toma 5/26/2016 14:53'!
initialize
	self
		calls: OrderedCollection new;
		pageRank: 1.0.! !

!CMMethodNode methodsFor: 'accessing' stamp: 'toma 5/26/2016 16:37'!
oldPageRank

	^ oldPageRank! !

!CMMethodNode methodsFor: 'accessing' stamp: 'toma 5/26/2016 16:37'!
oldPageRank: anObject

	oldPageRank := anObject! !

!CMMethodNode methodsFor: 'as yet unclassified' stamp: 'toma 5/26/2016 15:31'!
outdegree
	^self calls size! !

!CMMethodNode methodsFor: 'accessing' stamp: 'toma 5/26/2016 14:53'!
pageRank

	^ pageRank! !

!CMMethodNode methodsFor: 'accessing' stamp: 'toma 5/26/2016 14:53'!
pageRank: anObject

	pageRank := anObject! !

!CMMethodNode methodsFor: 'accessing' stamp: 'toma 5/26/2016 18:24'!
printOn: aStream
	aStream
		nextPutAll: self className;
		nextPutAll: '»';
		nextPutAll: self selector symbol asString.
	! !

!CMMethodNode methodsFor: 'accessing' stamp: 'toma 5/24/2016 16:55'!
selector

	^ selector! !

!CMMethodNode methodsFor: 'accessing' stamp: 'toma 5/24/2016 16:55'!
selector: anObject

	selector := anObject! !

Object subclass: #CMMethodSelectorGraph
	instanceVariableNames: 'methods selectors nodes terminalNodes pageRankResidual pageRankConstant pageRankPool'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeMine-CallGraph'!

!CMMethodSelectorGraph methodsFor: 'accessing' stamp: 'toma 5/24/2016 16:57'!
methods

	^ methods! !

!CMMethodSelectorGraph methodsFor: 'accessing' stamp: 'toma 5/24/2016 16:57'!
methods: anObject

	methods := anObject! !

!CMMethodSelectorGraph methodsFor: 'as yet unclassified' stamp: 'toma 5/26/2016 18:25'!
methodsByRank
	^(self methods
			sort: [:m1 :m2 | m1 pageRank > m2 pageRank])
			collect: [:m | m -> m pageRank]! !

!CMMethodSelectorGraph methodsFor: 'as yet unclassified' stamp: 'toma 5/26/2016 17:48'!
overflowPageRank
	"Determines the probability mass which would not
	propagate due to sinks in the graph. We need to re-distribute this."
	
	^terminalNodes inject: 0.0 into: [:sum :node | sum + (node pageRank)]! !

!CMMethodSelectorGraph methodsFor: 'accessing' stamp: 'toma 5/24/2016 16:57'!
selectors

	^ selectors! !

!CMMethodSelectorGraph methodsFor: 'accessing' stamp: 'toma 5/24/2016 16:57'!
selectors: anObject

	selectors := anObject! !

!CMMethodSelectorGraph methodsFor: 'as yet unclassified' stamp: 'toma 5/26/2016 18:18'!
selectorsByRank
	^(self selectors values
			sort: [:s1 :s2 | s1 pageRank > s2 pageRank])
			collect: [:s | s symbol -> s pageRank]! !

!CMMethodSelectorGraph methodsFor: 'as yet unclassified' stamp: 'toma 5/26/2016 18:05'!
startPageRank
	self startPageRank: 1.0! !

!CMMethodSelectorGraph methodsFor: 'as yet unclassified' stamp: 'toma 5/26/2016 17:44'!
startPageRank: residual

	nodes := self methods, self selectors values.
	nodes do: [:node | node pageRank: (1.0 / (nodes size))].
	terminalNodes := nodes select: [:node | node outdegree = 0].
	pageRankConstant := (1.0 - residual) / (nodes size).
	pageRankResidual := residual.
	pageRankPool := 0.
	
	! !

!CMMethodSelectorGraph methodsFor: 'as yet unclassified' stamp: 'toma 5/25/2016 16:21'!
summary
	^Dictionary newFrom: {
		#selectors -> (self selectors size).
		
		#implementedSelectors -> ((self selectors select: [:sel | sel hasImplementors]) size).
		
		#methods -> (self methods size).
		
		#implementorsPerSelector -> ((self selectors collect: [:s | s implementors size]) sum asFloat / (self selectors count: [:s | s hasImplementors])).
		
		#sendersPerSelector -> ((self selectors collect: [:s | s senders size]) sum asFloat / (self selectors size)).
		
		#callsPerMethod -> ((self methods collect: [:s | s calls size]) sum asFloat / (self methods size)).
		
		#selectorsPerMethod -> ((self methods collect: [:s | s calls asSet size]) sum asFloat / (self methods size))  
		}! !

!CMMethodSelectorGraph methodsFor: 'as yet unclassified' stamp: 'toma 5/26/2016 17:50'!
updateNodeRank: aNode
	
	| aggregate |
	
	aggregate := aNode inboundLinks
		inject: 0.0
		into: [:rank :node | 	rank + (node oldPageRank / (node outdegree))].
	aNode pageRank: (pageRankPool + (pageRankResidual * aggregate)).
	
	! !

!CMMethodSelectorGraph methodsFor: 'as yet unclassified' stamp: 'toma 5/26/2016 17:58'!
updatePageRank
	pageRankPool := pageRankConstant + (self overflowPageRank / nodes size).
	nodes do: [ :node | node oldPageRank: node pageRank].
	nodes do: [ :node | self updateNodeRank: node ].! !

!CMMethodSelectorGraph methodsFor: 'as yet unclassified' stamp: 'toma 5/26/2016 15:45'!
updatePageRank: iterations	
	1 to: iterations do: [:each | self updatePageRank]! !

Object subclass: #CMSelector
	instanceVariableNames: 'symbol implementors senders'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeMine'!

!CMSelector class methodsFor: 'as yet unclassified' stamp: 'toma 8/12/2015 17:14'!
named: aSymbol

	^(CMSelector new)
		symbol: aSymbol;
		yourself! !

!CMSelector methodsFor: 'accessing' stamp: 'toma 8/12/2015 17:08'!
implementors
	^ implementors! !

!CMSelector methodsFor: 'accessing' stamp: 'toma 8/12/2015 17:08'!
implementors: anObject
	implementors := anObject! !

!CMSelector methodsFor: 'as yet unclassified' stamp: 'toma 8/12/2015 17:13'!
initialize
	implementors := OrderedCollection new.
	senders := OrderedCollection new.! !

!CMSelector methodsFor: 'as yet unclassified' stamp: 'toma 8/12/2015 21:08'!
newImplementor: aSourceAst
	
	| method |

	method := CMMethod new.
	method 
		implementedSelector: self;
		sourceTree: aSourceAst.
	self implementors add: method.
	^method
! !

!CMSelector methodsFor: 'accessing' stamp: 'toma 8/12/2015 17:08'!
senders
	^ senders! !

!CMSelector methodsFor: 'accessing' stamp: 'toma 8/12/2015 17:08'!
senders: anObject
	senders := anObject! !

!CMSelector methodsFor: 'accessing' stamp: 'toma 8/12/2015 17:08'!
symbol
	^ symbol! !

!CMSelector methodsFor: 'accessing' stamp: 'toma 8/12/2015 17:08'!
symbol: anObject
	symbol := anObject! !

Object subclass: #CMSelectorNode
	instanceVariableNames: 'implementors symbol senders index pageRank oldPageRank'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeMine-CallGraph'!

!CMSelectorNode methodsFor: 'as yet unclassified' stamp: 'toma 5/24/2016 17:15'!
addImplementor: aMethod
	self implementors add: aMethod! !

!CMSelectorNode methodsFor: 'as yet unclassified' stamp: 'toma 5/24/2016 17:12'!
hasImplementors
	^self implementors size > 0! !

!CMSelectorNode methodsFor: 'accessing' stamp: 'toma 5/24/2016 16:56'!
implementors

	^ implementors! !

!CMSelectorNode methodsFor: 'accessing' stamp: 'toma 5/24/2016 16:56'!
implementors: anObject

	implementors := anObject! !

!CMSelectorNode methodsFor: 'as yet unclassified' stamp: 'toma 5/26/2016 17:03'!
inboundLinks
	^ self senders! !

!CMSelectorNode methodsFor: 'as yet unclassified' stamp: 'toma 5/26/2016 15:31'!
indegree
	^self senders size! !

!CMSelectorNode methodsFor: 'accessing' stamp: 'toma 5/26/2016 14:32'!
index

	^ index! !

!CMSelectorNode methodsFor: 'accessing' stamp: 'toma 5/26/2016 14:32'!
index: anObject

	index := anObject! !

!CMSelectorNode methodsFor: 'as yet unclassified' stamp: 'toma 5/26/2016 14:54'!
initialize
	self
		implementors: OrderedCollection new;
		senders: OrderedCollection new;
		pageRank: 1.0
		! !

!CMSelectorNode methodsFor: 'accessing' stamp: 'toma 5/26/2016 16:31'!
oldPageRank

	^ oldPageRank! !

!CMSelectorNode methodsFor: 'accessing' stamp: 'toma 5/26/2016 16:31'!
oldPageRank: anObject

	oldPageRank := anObject! !

!CMSelectorNode methodsFor: 'as yet unclassified' stamp: 'toma 5/26/2016 15:31'!
outdegree
	^self implementors size! !

!CMSelectorNode methodsFor: 'accessing' stamp: 'toma 5/26/2016 14:53'!
pageRank

	^ pageRank! !

!CMSelectorNode methodsFor: 'accessing' stamp: 'toma 5/26/2016 14:53'!
pageRank: anObject

	pageRank := anObject! !

!CMSelectorNode methodsFor: 'as yet unclassified' stamp: 'toma 5/26/2016 18:02'!
printOn: aStream
	self symbol printOn: aStream! !

!CMSelectorNode methodsFor: 'accessing' stamp: 'toma 5/24/2016 16:56'!
senders

	^ senders! !

!CMSelectorNode methodsFor: 'accessing' stamp: 'toma 5/24/2016 16:56'!
senders: anObject

	senders := anObject! !

!CMSelectorNode methodsFor: 'accessing' stamp: 'toma 5/24/2016 17:03'!
symbol

	^ symbol! !

!CMSelectorNode methodsFor: 'accessing' stamp: 'toma 5/24/2016 17:03'!
symbol: anObject

	symbol := anObject! !

Object subclass: #CMTMockClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeMine-Test-Mocks'!

!CMTMockClass methodsFor: 'as yet unclassified' stamp: 'toma 5/26/2016 17:28'!
mockMethod
	self halt.
	self mockMethod.
	self mockMethod2.
! !

!CMTMockClass methodsFor: 'as yet unclassified' stamp: 'toma 5/26/2016 17:25'!
mockMethod2
	self mockMethod! !

CMTMockClass subclass: #CMTMockClass2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeMine-Test-Mocks'!

Object subclass: #CXExpression
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeMine-Grammar'!

CXExpression subclass: #CXChoice
	instanceVariableNames: 'left right probability'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeMine-Grammar'!

!CXChoice methodsFor: 'accessing' stamp: 'toma 9/1/2015 18:28'!
left

	^ left! !

!CXChoice methodsFor: 'accessing' stamp: 'toma 9/1/2015 18:28'!
left: anObject

	left := anObject! !

!CXChoice methodsFor: 'as yet unclassified' stamp: 'toma 9/1/2015 18:36'!
parseOn: aParseState

	^(self left parseOn: aParseState) 
		onSuccess: [ :result | 
			(aParseState statsFor: self) goLeft. 
			result ]
		onFailure: [
			(self right parseOn: aParseState) 
			].! !

!CXChoice methodsFor: 'accessing' stamp: 'toma 9/1/2015 18:28'!
probability

	^ probability! !

!CXChoice methodsFor: 'accessing' stamp: 'toma 9/1/2015 18:28'!
probability: anObject

	probability := anObject! !

!CXChoice methodsFor: 'accessing' stamp: 'toma 9/1/2015 18:28'!
right

	^ right! !

!CXChoice methodsFor: 'accessing' stamp: 'toma 9/1/2015 18:28'!
right: anObject

	right := anObject! !

!CXChoice methodsFor: 'as yet unclassified' stamp: 'toma 9/1/2015 17:27'!
statClass
	^CXChoiceStat! !

CXExpression subclass: #CXString
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeMine-Grammar'!

Object subclass: #CXParseResult
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeMine-Grammar'!

CXParseResult subclass: #CXFailure
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeMine-Grammar'!

!CXFailure methodsFor: 'as yet unclassified' stamp: 'toma 9/1/2015 18:00'!
onSuccess: successBlock onFailure: failureBlock

	^ failureBlock value! !

!CXParseResult methodsFor: 'as yet unclassified' stamp: 'toma 9/1/2015 18:29'!
onSuccess: successBlock onFailure: failureBlock
	^ successBlock value: self

	! !

CXParseResult subclass: #CXToken
	instanceVariableNames: 'data from to'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeMine-Grammar'!

Object subclass: #CXParseState
	instanceVariableNames: 'data position stats'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeMine-Grammar'!

!CXParseState methodsFor: 'accessing' stamp: 'toma 9/1/2015 17:27'!
data

	^ data! !

!CXParseState methodsFor: 'accessing' stamp: 'toma 9/1/2015 17:27'!
data: anObject

	data := anObject! !

!CXParseState methodsFor: 'accessing' stamp: 'toma 9/1/2015 17:32'!
initialize

	super initialize.
	self position: 1.
	self stats: (Dictionary new).! !

!CXParseState methodsFor: 'accessing' stamp: 'toma 9/1/2015 17:27'!
position

	^ position! !

!CXParseState methodsFor: 'accessing' stamp: 'toma 9/1/2015 17:27'!
position: anObject

	position := anObject! !

!CXParseState methodsFor: 'accessing' stamp: 'toma 9/1/2015 17:27'!
stats

	^ stats! !

!CXParseState methodsFor: 'accessing' stamp: 'toma 9/1/2015 17:27'!
stats: anObject

	stats := anObject! !

!CXParseState methodsFor: 'as yet unclassified' stamp: 'toma 9/1/2015 17:26'!
statsFor: anExpression

	^self stats at: anExpression ifAbsentPut: [anExpression statClass new].! !

Object subclass: #CXStat
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeMine-Grammar'!

CXStat subclass: #CXChoiceStat
	instanceVariableNames: 'leftCount rightCount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeMine-Grammar'!

!CXChoiceStat methodsFor: 'as yet unclassified' stamp: 'toma 9/1/2015 17:22'!
goLeft
	self leftCount: (self leftCount + 1)! !

!CXChoiceStat methodsFor: 'as yet unclassified' stamp: 'toma 9/1/2015 17:22'!
goRight
	self rightCount: (self rightCount + 1)! !

!CXChoiceStat methodsFor: 'as yet unclassified' stamp: 'toma 9/1/2015 17:17'!
initialize
	super initialize.
	self
		leftCount: 0;
		rightCount: 0.	! !

!CXChoiceStat methodsFor: 'accessing' stamp: 'toma 9/1/2015 17:14'!
leftCount

	^ leftCount! !

!CXChoiceStat methodsFor: 'accessing' stamp: 'toma 9/1/2015 17:14'!
leftCount: anObject

	leftCount := anObject! !

!CXChoiceStat methodsFor: 'as yet unclassified' stamp: 'toma 9/1/2015 17:20'!
probability
	| sum |
	"maximum likelihood estimate for P given collected statistics"
	sum := self leftCount + (self rightCount).
	(sum = 0)
		ifTrue: [	 ^ self  leftCount asFloat / sum ]
		ifFalse: [ ^ 0.5 ]
	! !

!CXChoiceStat methodsFor: 'accessing' stamp: 'toma 9/1/2015 17:14'!
rightCount

	^ rightCount! !

!CXChoiceStat methodsFor: 'accessing' stamp: 'toma 9/1/2015 17:14'!
rightCount: anObject

	rightCount := anObject! !

Object subclass: #CmBinding
	instanceVariableNames: 'context varname definingRelation usingRelations'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeMine-Tracing'!

!CmBinding methodsFor: 'accessing' stamp: 'toma 5/13/2016 12:53'!
context

	^ context! !

!CmBinding methodsFor: 'accessing' stamp: 'toma 5/13/2016 12:53'!
context: anObject

	context := anObject! !

!CmBinding methodsFor: 'accessing' stamp: 'toma 5/13/2016 12:53'!
definingRelation

	^ definingRelation! !

!CmBinding methodsFor: 'accessing' stamp: 'toma 5/13/2016 12:53'!
definingRelation: anObject

	definingRelation := anObject! !

!CmBinding methodsFor: 'accessing' stamp: 'toma 5/13/2016 12:53'!
usingRelations

	^ usingRelations! !

!CmBinding methodsFor: 'accessing' stamp: 'toma 5/13/2016 12:53'!
usingRelations: anObject

	usingRelations := anObject! !

!CmBinding methodsFor: 'accessing' stamp: 'toma 5/13/2016 12:53'!
varname

	^ varname! !

!CmBinding methodsFor: 'accessing' stamp: 'toma 5/13/2016 12:53'!
varname: anObject

	varname := anObject! !

Object subclass: #CmTraceOperation
	instanceVariableNames: 'selector participants'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeMine-Tracing'!

!CmTraceOperation methodsFor: 'accessing' stamp: 'toma 5/13/2016 12:59'!
participants

	^ participants! !

!CmTraceOperation methodsFor: 'accessing' stamp: 'toma 5/13/2016 12:59'!
participants: anObject

	participants := anObject! !

!CmTraceOperation methodsFor: 'accessing' stamp: 'toma 5/13/2016 12:59'!
selector

	^ selector! !

!CmTraceOperation methodsFor: 'accessing' stamp: 'toma 5/13/2016 12:59'!
selector: anObject

	selector := anObject! !

Object subclass: #CmTracelet
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeMine-Tracing'!

Object subclass: #CmTracingContext
	instanceVariableNames: 'parent args argsDeclared temps tempsDeclared'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeMine-Tracing'!

!CmTracingContext methodsFor: 'accessing' stamp: 'toma 5/13/2016 12:47'!
args

	^ args! !

!CmTracingContext methodsFor: 'accessing' stamp: 'toma 5/13/2016 12:47'!
args: anObject

	args := anObject! !

!CmTracingContext methodsFor: 'accessing' stamp: 'toma 5/13/2016 12:47'!
argsDeclared

	^ argsDeclared! !

!CmTracingContext methodsFor: 'accessing' stamp: 'toma 5/13/2016 12:47'!
argsDeclared: anObject

	argsDeclared := anObject! !

!CmTracingContext methodsFor: 'as yet unclassified' stamp: 'toma 5/13/2016 12:53'!
defineArgument: name
	self args at: name put: (CmBinding new context: self).
	self argsDeclared add: name.
	^self args at: name! !

!CmTracingContext methodsFor: 'as yet unclassified' stamp: 'toma 5/13/2016 12:54'!
defineTemporary: name
	self temps at: name put: (CmBinding new context: self).
	self tempsDeclared add: name.
	^self temps at: name.! !

!CmTracingContext methodsFor: 'as yet unclassified' stamp: 'toma 5/13/2016 12:48'!
initialize
	self
		args: Dictionary new;
		argsDeclared: Set new;
		parent: nil;
		temps: Dictionary new;
		tempsDeclared: Set new.
	! !

!CmTracingContext methodsFor: 'accessing' stamp: 'toma 5/13/2016 12:47'!
parent

	^ parent! !

!CmTracingContext methodsFor: 'accessing' stamp: 'toma 5/13/2016 12:47'!
parent: anObject

	parent := anObject! !

!CmTracingContext methodsFor: 'accessing' stamp: 'toma 5/13/2016 12:47'!
temps

	^ temps! !

!CmTracingContext methodsFor: 'accessing' stamp: 'toma 5/13/2016 12:47'!
temps: anObject

	temps := anObject! !

!CmTracingContext methodsFor: 'accessing' stamp: 'toma 5/13/2016 12:47'!
tempsDeclared

	^ tempsDeclared! !

!CmTracingContext methodsFor: 'accessing' stamp: 'toma 5/13/2016 12:47'!
tempsDeclared: anObject

	tempsDeclared := anObject! !
